import java.util.Scanner;

/**
 * ITI 1220 Assignment 7, Question 2 Sample solution
 * 
 * @author Alan Williams
 */
public class Permutations
{

	/**
	 * Main method to try out the permute( ) method.
	 * 
	 * @param args
	 */
	public static void main( String[] args )
	{
		Scanner keyboard = new Scanner( System.in );
		System.out.println( "Enter a string: " );
		String s = keyboard.nextLine( );
		System.out.println( );
		System.out.println( "Permutations:" );
		String[] perms = Permutations.permute( s );
		for ( int index = 0; index < perms.length; index++ )
		{
			System.out.println( perms[index] );
		}
	}

	/**
	 * Returns the value of n!
	 * <p>
	 * This is a recursive method to calculate the factorial of n. It is needed
	 * to determine the number of permutations of n distinct characters, in
	 * order to allocate array space for each permutation.
	 * 
	 * @param n
	 *            An integer >= 0
	 * @return The value of n!
	 */
	public static int factorial( int n )
	{
		// DECLARE VARIABLES / DATA DICTIONARY

		int result;

		// BODY OF ALGORITHM

		// Check for base case

		if ( n == 0 )
		{
			result = 1;
		}
		else
		{
			result = n * factorial( n - 1 );
		}

		// RETURN RESULT

		return result;
	}

	/**
	 * Generates all permutations of a String.
	 * <p>
	 * This method determines all possible ways that the characters in a String
	 * can be re-arranged. It is assumed that the characters are distinct, so
	 * that there are no indistinguishable permutations.
	 * <p>
	 * The algorithm is recursive: for each character in the string, generate
	 * all permutations of the string with that character removed. Then,
	 * concatenate the character removed to each string returned by the
	 * recursive call.
	 * 
	 * @param aString
	 *            A String (don't make it too long, as n! values will be
	 *            generated).
	 * @return An array of String values containing all permuations of aString.
	 */
	public static String[] permute( String aString )
	{
		// DECLARE VARIABLES / DATA DICTIONARY

		String[] permList; 		// RESULT: Array of permutations
		String[] recPermList; 	// Returned from recursive call on smaller
								// string
		String restOfString; 	// Input string with one character removed
		int permIndex; 			// Index for items in array recPermList
		int nextNewPerm; 		// Index for items in array permList
		int charIndex; 			// Position number of character removed.

		// Check for base case

		if ( aString.length( ) == 0 )
		{
			// Base case is an empty string. Return a new array containing
			// the empty string.

			permList = new String[1];
			permList[0] = "";
		}
		else
		{
			// Determine size of array needed to hold result.

			permList = new String[factorial( aString.length( ) )];
			nextNewPerm = 0;

			// For each character in aString:

			charIndex = 0;
			while ( charIndex < aString.length( ) )
			{
				// Remove the character at position 'charIndex' from the string,
				// leaving a shorter string.

				restOfString = aString.substring( 0, charIndex )
						+ aString.substring( charIndex + 1 );

				// Recursive call: find permutations of the rest of the string.

				recPermList = permute( restOfString );

				// For each permutation found recursively, we have to
				// concatenate the character that was removed. Also, we have to
				// copy the recursive call results into the appropriate
				// location in our own result array.

				permIndex = 0;
				while ( permIndex < recPermList.length )
				{
					permList[nextNewPerm] = recPermList[permIndex]
							+ aString.charAt( charIndex );
					nextNewPerm = nextNewPerm + 1;
					permIndex = permIndex + 1;
				}

				// Go to next character.

				charIndex = charIndex + 1;
			}
		}

		// RETURN RESULT

		return permList;
	}
}
